﻿Type=Activity
Version=3.82
B4A=true
@EndOfDesignText@
#Region Module Attributes
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals

End Sub

Sub Globals
	Dim pnlEditTools As Panel
	Dim scvEdit As ScrollView
	Dim btnEditAdd, btnEditModif, btnEditMove As Button
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("Edit")
	Activity.Title = Main.ProgName & " : Edit"
	
	' sets the background color of the ScrollView.Panel
	scvEdit.Panel.Color = Colors.RGB(0, 96, 0) 
End Sub

Sub Activity_Resume
	Dim col As Int
	
	' generates the Edit ScrollView.Panel content
	' adds a Label and an EditText view for each column
	For col = 0 To Main.NumberOfColumns - 1
		Dim lbl As Label
		lbl.Initialize("")
		scvEdit.Panel.AddView(lbl, 10dip, col * Main.TotalHeight, scvEdit.Width - 20dip, Main.lblHeight)
		lbl.Gravity = Gravity.LEFT + Gravity.CENTER_VERTICAL
		lbl.Tag = col
		lbl.TextColor = Colors.Yellow
		lbl.Text = Main.ColumnName(lbl.Tag)
		
		Dim edt As EditText
		edt.Initialize("edtEdit")
		scvEdit.Panel.AddView(edt, 5dip, col * Main.TotalHeight + Main.lblHeight, scvEdit.Width - 10dip, Main.edtHeight)
		edt.Gravity = Gravity.LEFT
		edt.Tag = col
		If col = 0 Then
			edt.Enabled = False
		End If
	Next
	scvEdit.Panel.Height = Main.NumberOfColumns * Main.TotalHeight
	
	' filling of the EditText views
	If Main.NumberOfRows > 0 Then
		EditDispDataset(Main.SelectedRow)  ' routine for the filling
	Else
		' What does this GetView(col * 2 + 1)  do ?
		' There are two views per column a Label and an EditText
		' To get the EditText for column col we calculate the index with col * 2 + 1
		For col = 0 To Main.NumberOfColumns - 1
			Dim edt As EditText
			edt = scvEdit.Panel.GetView(col * 2 + 1)
			edt.Text = ""
		Next
	End If
End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub btnEditAdd_Click
	Dim row(Main.NumberOfColumns) As String
	Dim col, hh As Int
	Dim query As String
	
	' gets the the max ID value to increment it for the RowID List
	query = "SELECT max(" & Main.ColumnName(0) & ") FROM " & Main.DBTableName
	row(0) = Main.SQL1.ExecQuerySingleResult(query) + 1
	
	' constructs the SQL query
	query = "INSERT INTO " & Main.DBTableName & " VALUES (NULL"
	For col = 1 To Main.NumberOfColumns - 1
		Dim edt As EditText
		edt = scvEdit.Panel.GetView(col * 2 + 1)
		row(edt.Tag) = edt.Text
		query = query & " , '" & edt.Text & "'"
		If edt.Text = "" Then ' checks if the data is missing
			hh = hh + 1
		End If
	Next
	query = query & ")"
	
	' check if there are missing data
	If hh > 0 Then
		Msgbox("There are " & hh & " data missing ", "Attention")
		Return
	End If
	
	' shows the Edit Modify button if the NumberOfRows > 0
	If Main.NumberOfRows > 0 Then
		btnEditModif.Visible = True
	End If
	Main.RowID.Add(row(0))				 	' updates the RowID List
	Main.SQL1.ExecNonQuery(query)		' updates the database
End Sub

Sub btnEditModif_Click
	Dim row(Main.NumberOfColumns) As String
	Dim col As Int
	Dim query As String
	
	' gets the new data
	For col = 0 To Main.NumberOfColumns - 1
		Dim edt As EditText
		edt = scvEdit.Panel.GetView(col * 2 + 1)
		row(edt.Tag) = edt.Text
	Next
	
	' constructs the SQL query
	query = "UPDATE " & Main.DBTableName & " Set " & Main.ColumnName(0) & " = '" & row(0)
	For col = 1 To Main.NumberOfColumns - 1
		query = query & "', " & Main.ColumnName(col) & " = '" & row(col)
	Next 
	query = query & "' WHERE " & Main.ColumnName(0) & " = '" & Main.SelectedID & "'"
	
	Main.SQL1.ExecNonQuery(query)		' updates the database
End Sub

' Sets the EditText properties with the data of the selected dataset
Sub EditDispDataset(Row As Int)
	Dim Cursor1 As Cursor
	Dim col As Int
	Dim query As String
	
	' gets the dataset with current selected data ID
	query = "SELECT * FROM " & Main.DBTableName & " WHERE " & Main.ColumnName(0) & " = " & Main.RowID.Get(Row)
	Cursor1 = Main.SQL1.ExecQuery(query)
	Cursor1.Position = 0
	
	' sets the Text properties
	For col = 0 To Main.NumberOfColumns - 1
		Dim edt As EditText
		edt = scvEdit.Panel.GetView(col * 2 + 1)
		edt.Text = Cursor1.GetString(Main.ColumnName(edt.Tag))
	Next
End Sub

'Navigation button Click event
'We use the same event routine for both buttons Prev and Next 
Sub btnEditMove_Click
	Dim rc As RowCol
	Dim row As Int
	
	If btnEditMove.IsInitialized Then
		btnEditMove.Visible = True	' sets the previous button visible to true
	End If
	
	btnEditMove = Sender					' remembers the current used button
	
	row = Main.SelectedRow
	
	Select btnEditMove.Tag
	Case "EditPrev" 
		row = row - 1
		If row = 0 Then
			btnEditMove.Visible = False		' hides the Prev button if row = 0
		End If
	Case "EditNext"
		row = row + 1
		If row = Main.NumberOfRows - 1 Then
			btnEditMove.Visible = False		' hides the Prev button if row = NumberOfRows - 1
		End If
	End Select
	rc.row = row

	Main.SelectedRow = row				' updates the current row index
	EditDispDataset(Main.SelectedRow)	' updates the EditText.Text properties
End Sub

'Jumps to the first or last dataset
Sub btnEditMove_LongClick
	Dim rc As RowCol
	Dim row As Int
	
	If btnEditMove.IsInitialized Then
		btnEditMove.Visible = True	' sets the previous button visible to true
	End If
	
	btnEditMove = Sender					' remembers the current used button
	
	Select btnEditMove.Tag
	Case "EditPrev" 
		btnEditMove.Visible = False
		row = 0
	Case "EditNext"
		btnEditMove.Visible = False
		row = Main.NumberOfRows - 1
	End Select
	rc.Col = 0
	rc.row = row
	
	Main.SelectedRow = row
	EditDispDataset(Main.SelectedRow)
End Sub