﻿Type=Activity
Version=3.82
B4A=true
@EndOfDesignText@
#Region Module Attributes
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	Public Query As String

	Dim FilterType = "AND" As String	' variable for the filter AND / OR
	Dim FilterCriteria As List				' List of filter values
	Dim FilterCriteriaID As List			' List of the selected Spinner items
End Sub

Sub Globals
	Dim pnlFilterTools As Panel
	Dim scvFilter As ScrollView
	Dim btnFilterGo, btnFilterAND, btnFilterOR As Button
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("Filter")
	Activity.Color = Colors.RGB(0, 0, 128)
	Activity.Title = Main.ProgName & " : Filter" 
	
	scvFilter.Panel.Color = Colors.RGB(0, 0, 128)	' sets the ScrollView.Panel background color
End Sub

Sub Activity_Resume
	Dim row, col As Int
	Dim Curs As Cursor
	
	' sets the filter criteria List
	If FilterCriteria.IsInitialized = False Then
		FilterCriteria.Initialize
		FilterCriteriaID.Initialize
		For col = 0 To Main.NumberOfColumns - 1
			FilterCriteria.Add("ALL")
			FilterCriteriaID.Add(0)
		Next
	End If

	For col = 1 To Main.NumberOfColumns - 1
		' Adds the Label for each column except the first one, the ID
		Dim lbl As Label
		lbl.Initialize("")
		scvFilter.Panel.AddView(lbl, 10dip, (col - 1) * Main.TotalHeight, scvFilter.Width - 20dip, Main.lblHeight)
		lbl.Gravity = Gravity.LEFT + Gravity.CENTER_VERTICAL
		lbl.Tag = col
		lbl.TextColor = Colors.Yellow
		lbl.Text = Main.ColumnName(lbl.Tag)
		
		' Adds the Spinner for each column except the first one, the ID
		Dim spn As Spinner
		spn.Initialize("spnFilter")
		scvFilter.Panel.AddView(spn, 5dip, (col - 1) * Main.TotalHeight + Main.lblHeight, scvFilter.Width - 10dip, Main.edtHeight)
		spn.Tag = col
		
		' We get all DISTINCT values for each column and fill the Spinners with these values 
		Dim txt As String
		txt = "SELECT DISTINCT " & Main.ColumnName(col) & " FROM " & Main.DBTableName & " ORDER BY " & Main.ColumnName(col) & " ASC"
		Curs = Main.SQL1.ExecQuery(txt)
		spn.Clear
		spn.Add("ALL")
		For row = 0 To Curs.RowCount - 1
			Curs.Position = row
			spn.Add(Curs.GetString(Main.ColumnName(col)))
		Next
		spn.SelectedIndex = FilterCriteriaID.Get(col) ' initializes the Filter row for the given column
	Next

	
	scvFilter.Panel.Height = (Main.NumberOfColumns - 1) * Main.TotalHeight
	Curs.Close
	
	' stes the column sort orientation to ASC 
	For col = 0 To Main.NumberOfColumns - 1
		Main.SortDirection(col) = "ASC"
	Next
End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

'Closes the Filter Activity and gets the Filter query
Sub btnFilterGo_Click
	Main.Filtered = True
	Main.SelectedRow = -1
	GetFilterQuery
	Activity.Finish
End Sub

'Sets the Filter operator to AND
Sub btnFilterAND_Click
	btnFilterOR.TextColor = Colors.Red
	FilterType = "AND"
	btnFilterAND.TextColor = Colors.RGB(0, 255, 0)
End Sub

'Sets the Filter operator to AND
Sub btnFilterOR_Click
	btnFilterAND.TextColor = Colors.Red
	FilterType = "OR"
	btnFilterOR.TextColor = Colors.RGB(0, 255, 0)
End Sub

'Clears all Filter selections
Sub btnFilterClearAll_Click
	Dim col As Int
	
	For col = 0 To Main.NumberOfColumns - 2
		Dim spn As Spinner
		spn = scvFilter.Panel.GetView(col * 2 + 1)
		spn.SelectedIndex = 0
	Next
End Sub

'Updates the Filter ID and criteria
Sub spnFilter_ItemClick (Position As Int, Value As Object)
	Dim spn As Spinner
	
	spn = Sender
	FilterCriteria.Set(spn.Tag, Value)
	FilterCriteriaID.Set(spn.Tag, Position)
End Sub

'Gets the Filter query
Sub GetFilterQuery
	Dim col As Int

	Query = ""
	For col = 1 To Main.NumberOfColumns - 1
		Dim fc As String
		fc = FilterCriteria.Get(col)
		If fc <> "ALL" Then
			If Query = "" Then
				Query = Query & Main.ColumnName(col) & " LIKE '" & fc & "'"
			Else
				Query = Query & " " & FilterType & " " & Main.ColumnName(col) & " LIKE '" & fc & "'"
			End If
		End If
	Next
	If Query <> "" Then
		Query = " WHERE " & Query
	End If
End Sub

